using System;
using System.Diagnostics;
using System.Reflection;
using System.Runtime.InteropServices;
using System.Threading;
public class StayAwake
{
  public static void Main(String[] args)
  {
    if (args.Length < 1)
    {
      Console.WriteLine("Stay awake 0.22 - Keeps the OS from sleeping");
      Console.WriteLine();
      Console.WriteLine("Missing argument. Syntax: StayAwake minutes");
      Console.WriteLine();
      Console.WriteLine("Example: StayAwake 60");
      Console.WriteLine();
    }
    else if (args.Length == 1)
    {
      if (IsInteger(args[0]))
      {
        Process proc = new Process();
        proc.StartInfo.FileName = Assembly.GetExecutingAssembly().Location;
        proc.StartInfo.Arguments = args[0] + " RunSync";
        proc.Start();
      }
      else
      {
        Console.WriteLine("Not an integer");
      }
    }
    else if (args.Length == 2)
    {
      if (IsInteger(args[0]))
      {
        SleeplessWait(Convert.ToInt32(args[0]));
      }
      else
      {
        Console.WriteLine("Not an integer");
      }
    }
  }

  [DllImport("kernel32.dll", CharSet = CharSet.Auto, SetLastError = true)]
  static extern EXECUTION_STATE SetThreadExecutionState(
  EXECUTION_STATE flags);
  [Flags]
  
  public enum EXECUTION_STATE : uint
  {
    ES_SYSTEM_REQUIRED = 0x00000001,
    ES_DISPLAY_REQUIRED = 0x00000002,
    ES_CONTINUOUS = 0x80000000
  }

  public static void SleeplessWait(int minutes)
  {
    SetThreadExecutionState(
      EXECUTION_STATE.ES_SYSTEM_REQUIRED |
      EXECUTION_STATE.ES_CONTINUOUS);
    try
    {
      DateTime startTime = DateTime.Now;
      DateTime endTime;
      endTime = DateTime.Now + new TimeSpan(0, minutes, 0);
      Console.WriteLine("Staying awake until " + endTime);
      Thread.Sleep(minutes * 60000);
    }
    catch (Exception e)
    {
      Console.WriteLine(e.Message);
    }
    finally
    {
      SetThreadExecutionState(EXECUTION_STATE.ES_CONTINUOUS);
    }    
  }
  
  public static bool IsInteger(string aString)
  {
    try
    {
      Convert.ToInt32(aString);
      return true;
    }
    catch
    {
      return false;
    }
  }
}